#!/usr/bin/wish8.3
##################################################
# Tcl/Tk console keyboard layout generator
##################################################

array set LAYOUT {
    basic      ""
    doskeys    " MS-DOS"
    typewriter ""
    winkeys    " MS Windows"
}

array set CHARMAP {
    cp1251     "CP1251"
    cp866      "CP866"
    iso-8859-5 "ISO-8859-5"
    koi8-r     "KOI8-R"
    utf-8      "UTF-8"
}

array set LOCK {
    alt_lk        " Alt"
    caps_lk       "Caps Lock"
    ctrl_lk       " Control"
    ctrl_shift_lk "Control+ Shift"
    win_lk        " Windows"
}

##################################################

wm title . "   "
wm iconname . "genkbd"

set layout   "basic"
set charmap  "koi8-r"
set lock     "alt_lk"
set map_file "ru.map"

proc radio_list {frm name g_arr var} {
    upvar $g_arr arr
    frame $frm
    pack $frm -side left -anchor nw
    label $frm.h -relief raise -text $name
    pack $frm.h -fill x
    foreach i [lsort [array names arr]] {
        radiobutton $frm.$i -text $arr($i) -value $i -variable $var
        pack $frm.$i -anchor w
    }
}

proc generate_map {} {
    global layout charmap lock map_file
    exec m4 -D$layout -D$charmap -D$lock ru.m4 > $map_file
    set txt [.f.gen cget -text]
    .f.gen configure -text "!"
    after 1500 ".f.gen configure -text $txt"
}

frame .f
label .f.name -text "  :"
entry .f.inp -textvar map_file
button .f.gen -text "..." -command {generate_map} -width 15
pack .f -side bottom -fill x
pack .f.gen -side right
pack .f.name .f.inp -side left

radio_list .lt ""     LAYOUT  layout
radio_list .cm ""       CHARMAP charmap
radio_list .lk "" LOCK    lock
